#include "xbasic_types.h"
#include "xio.h"
#include "xparameters.h"
#include "xuartlite_l.h"

extern char buffer[BUF_SIZE];
extern int head;
extern int tail;
extern int count;

/*
 * Interrupt service routine for the UART
 */
void uart_handler(void *callback)
{
  Xuint32 IsrStatus;
  
  Xuint8 incoming_character;

  /* Check the ISR status register so we can identify the interrupt source */
  IsrStatus = XIo_In32(XPAR_MYUART_BASEADDR + XUL_STATUS_REG_OFFSET);
  
  if ((IsrStatus & (XUL_SR_RX_FIFO_FULL | XUL_SR_RX_FIFO_VALID_DATA)) != 0) {
    /* The input FIFO contains data: read it */
    incoming_character =
      (Xuint8) XIo_In32( XPAR_MYUART_BASEADDR + XUL_RX_FIFO_OFFSET );

    if ( count < BUF_SIZE )
    {
        // interrupts are disabled to prevent simultaneous reading and
        // writing into the character buffer
        microblaze_disable_interrupts();
        buffer[tail] = incoming_character;
        tail++;
        tail = (tail >= BUF_SIZE) ? (tail - BUF_SIZE) : tail;
        count++;
        microblaze_enable_interrupts();
    }
  }
 
  if ((IsrStatus & XUL_SR_TX_FIFO_EMPTY) != 0) {
    /* The output FIFO is empty: we can send another character */
  }
   
}
