//Main Pac-Man Game Engine
//Ke Xu 
//ESD TEAM Pac-Man
//5/7/2004


#include "xbasic_types.h"
#include "xio.h"
#include "xintc_l.h"
#include "xuartlite_l.h"
        
#define TRUE 1
#define FALSE 0
#define W 80
#define H 60
#define VGA_START 0x00800000
#define LAST_LINE 59
#define C_CURSOR 24
#define C_SPACE 32
#define C_BACKSPACE 8
#define C_CRETURN 10
#define C_NEWLINE 13
#define C_RETURN 13
#define BUF_SIZE 10
#define WIN_SCORE 400
#define AI_COUNT 5
#define PLAYER_COUNT 1
#define P1UP 112
#define P1DOWN 59
#define P1LEFT 108
#define P1RIGHT 39
#define P1PAUSE 111 
#define P2UP 119
#define P2DOWN 115
#define P2LEFT 97
#define P2RIGHT 100
#define P2PAUSE 101




// defined in isr.c
extern void uart_handler(void *callback);

// circular character buffer
char buffer[BUF_SIZE];
int head = 0;
int tail = 0;
int count = 0;
int grid[80][60];
unsigned long int next=1;
struct player ai;
struct player ai2;
struct player ai3;
struct player ai4;
struct player ai5;

int rand()
{
  next=next*1103515245+12345;
  return (unsigned int)(next/65536)%32768;
  
  
}

int dist(x1,x2,y1,y2){
  return (x2-x1)*(x2-x1)+(y2-y1)*(y2-y1);
}



//basic structure of a tile holding 1 bit
struct tile{
  unsigned int tiletype:1;
  unsigned int x:7;
  unsigned int y:6;  
};

struct player{
  int x,y,prevx,prevy,score,power,direction,alive,invulnerable,chewing,attack;
  int aiType,it,ct,at;//default no AI
};


/*
 * setup_interrupts: Initialize the interrupt sources and handlers
 *
 * Should be called once when the system starts
 *
 * The main _interrupt_handler() function from Xilinx
 *
 * Saves and restores CPU context, etc.
 *
 * Sees which interrupts are pending, and for each it
 *     acknowledges the interrupt and
 *     calls a user-defined interrupt handler in Xintc_InterruptVectorTable
 *
 * Place interrupt service routines in isr.c to ensure they are placed in
 * the proper memory segment.
 */
void setup_interrupts()
{
  /*
   * Reset the interrupt controller peripheral
   */

  /* Disable the interrupt signal */
  XIntc_mMasterDisable(XPAR_INTC_SINGLE_BASEADDR);

  /* Disable all interrupt sources */
  XIntc_mEnableIntr(XPAR_INTC_SINGLE_BASEADDR,0);

  /* Acknowledge all possible interrupt sources
     to make sure none are pending */
  XIntc_mAckIntr(XPAR_INTC_SINGLE_BASEADDR, 0xffffffff);

  /*
   * Install the UART interrupt handler
   */

  XIntc_InterruptVectorTable[XPAR_INTC_MYUART_INTERRUPT_INTR].Handler =
    uart_handler;

  /*
   * Enable interrupt sources
   */

  /* Enable CPU interrupts */
  microblaze_enable_interrupts();

  /* Enable interrupts from the interrupt controller */
  XIntc_mMasterEnable(XPAR_INTC_SINGLE_BASEADDR);

  /* Tell the interrupt controller to accept interrupts from the UART */
  XIntc_mEnableIntr(XPAR_INTC_SINGLE_BASEADDR, XPAR_MYUART_INTERRUPT_MASK);
  
  /* Enable UART interrupt generation */
  XUartLite_mEnableIntr(XPAR_MYUART_BASEADDR);
}

//  AI that just tries to to reach no walled areas
void default_AI(struct player *ai){
  int zx=0,zy=0,x=0,y=0;
  ai->prevx=ai->x;
  ai->prevy=ai->y;
  if(grid[(ai->x)+1][ai->y]!=2){
    if(grid[(ai->x)+1][ai->y]==1){
      x=ai->x+1;
      y=ai->y;
    }
    else{
      zx=ai->x+1;
      zy=ai->y;
    }
  }
  
  if(grid[(ai->x)-1][ai->y]!=2){
    if(grid[(ai->x)-1][ai->y]==1){
      x=ai->x-1;
      y=ai->y;
    }    
    else{
      zx=ai->x-1;
      zy=ai->y;
    }  
  }
  
  if(grid[ai->x][(ai->y)+1]!=2){
    if(grid[(ai->x)][ai->y+1]==1){
      y=ai->y+1;
      x=ai->x;
    }
    else{
      zy=ai->y+1;
      zx=ai->x;
    }  
  }
  
  if(grid[ai->x][(ai->y)-1]!=2){
    if(grid[(ai->x)][ai->y-1]==1){
      y=ai->y-1;
      x=ai->x;
    }
    else{
      zy=ai->y-1;
      zx=ai->x;
    }
  } 

  if(x!=0 || y!=0){
    ai->x=x;
    ai->y=y;
    ai->score++;
    
  }
  else if(zx!=0 || zy!=0){
    ai->x=zx;
    ai->y=zy;
  }
}


void end_game(){
  int i;
  for(i=36; i<46; i++) XIo_Out8(VGA_START + 36, 0);

}

void lost_game(int playernum){
  if(playernum==1){
    XIo_Out8(VGA_START + 35+80, 15+96);
    XIo_Out8(VGA_START + 36+80, 11+96);
    XIo_Out8(VGA_START + 37+80, 0);
    XIo_Out8(VGA_START + 38+80, 13+64);
  } 
  else{
    XIo_Out8(VGA_START + 43+80, 15+96);
    XIo_Out8(VGA_START + 44+80, 12+96);
    XIo_Out8(VGA_START + 45+80, 0);
    XIo_Out8(VGA_START + 46+80, 13+64);
  }  


 
}


void won_game(int playernum){
  
   if(playernum==1){
     XIo_Out8(VGA_START + 35+80, 15+96);
     XIo_Out8(VGA_START + 36+80, 11+96);
     XIo_Out8(VGA_START + 37+80, 0);
     XIo_Out8(VGA_START + 38+80, 14+32);
   } 
   else{
     XIo_Out8(VGA_START + 43+80, 15+96);
     XIo_Out8(VGA_START + 44+80, 12+96);
     XIo_Out8(VGA_START + 45+80, 0);
     XIo_Out8(VGA_START + 46+80, 14+32);
   }  
  
}

void make_invulnerable(int playernum,int type){
  int c;
  if(type==1)c=9+112;
  else c=0;

  if(playernum==2){
    XIo_Out8(VGA_START + 50+80, c);
  }
  else{
    XIo_Out8(VGA_START + 2+80, c);
  }

}

void make_chewing(int playernum, int type){
  int c;
  if(type==1)c=9+32;
  else c=0;
  if(playernum==2){
    XIo_Out8(VGA_START + 52+80, c);
  }
  else{
    XIo_Out8(VGA_START + 4+80, c);
  }

}

void make_attack(int playernum, int type){
  int c;
  if(type==1)c=9+64;
  else c=0;
  if(playernum==2){
    XIo_Out8(VGA_START + 54+80, c);
  }
  else{
    XIo_Out8(VGA_START + 6+80, c);
  }

}



//======================================================================
// Main function
//======================================================================
int main()
{
    // for keeping track of cursor position
    int cursor_x = 1;
    int cursor_y = 3;
    int test_x=1,test_y=3;
    int header_delay=0;
    int unit_delay=0;
    int cursor_delay = 0;  
    int player_delay=0;
    char tmp;
    int x,zx,zy;
    int y,i,j,k,newmove, emptyTile,num_players=2;
    int term_size=12;
    int tile_count=0;
    int win_value=100;
    int movemaker=0;
    int totalscore=0;
    struct player* allunits[AI_COUNT];
    struct player* allplayers[PLAYER_COUNT];
    int player_clock=0;
    int AImoves[4][3];
    int change=FALSE;
    struct player p;
    struct player p2;



 // Enable the instruction cache: makes the code run 6 times faster
 microblaze_enable_icache();
    setup_interrupts();
    
    //keep track of AIs
    allunits[0]=&ai;
    if(AI_COUNT>=2)allunits[1]=&ai2;
    if(AI_COUNT>=3)allunits[2]=&ai3;
    if(AI_COUNT>=4)allunits[3]=&ai4;
    if(AI_COUNT>=5)allunits[4]=&ai5;
    //Keep track of players
    allplayers[0]=&p;
    if(PLAYER_COUNT>=2){
      allplayers[1]=&p2;
    }
    
    
    // Erase the screen
    for(x=0; x<H*W; x++)
      XIo_Out8(VGA_START + x, 0); 


    for(i=0; i<W; i++){
      for(j=0; j<H; j++){
	grid[i][j]=0;
      }
    }  
    
    //initialize player1
    p.prevx=1;
    p.prevy=3;
    p.x=1;
    p.y=3;
    p.score=1;//zero score and no powers initially
    p.power=0;
    p.direction=0;
    p.alive=1;
    p.invulnerable=FALSE;
    p.chewing=FALSE;
    p.attack=FALSE;

    //initialize player2 on otherside of map
    p2.prevx=78;
    p2.prevy=58;
    p2.x=78;
    p2.y=58;
    p2.score=1;//zero score and no powers initially
    p2.power=0;
    p2.direction=0;
    p2.alive=1;
    p2.invulnerable=FALSE;
    p2.chewing=FALSE;
    p2.attack=FALSE;

    
    for(i=0; i<=80; i++){
      XIo_Out8( VGA_START +i+2*W, 2+32);
      grid[i][2]=2;
    }
    for(i=2; i<=59; i++) {
      XIo_Out8( VGA_START +0+i*W, 1+32);
      grid[0][i]=1;
    }
    for(i=0; i<=79; i++) {
      XIo_Out8( VGA_START +i+59*W, 2+32);
      grid[i][59]=2;
    }
    for(i=2; i<=59; i++) {
      XIo_Out8( VGA_START +79+i*W, 1+32);
      grid[79][i]=1;
    }
    /*
     {1,10,27,10,2},//1
     {14,10,14,20,1},//2
     {16,12,16,22,1},//3
     {19,10,19,22,1},//4
     {25,12,25,26,1},//5
    */

    for(i=3; i<=27; i++){
      XIo_Out8( VGA_START +i+10*W, 2+32);
      grid[i][10]=2;
    }
    for(i=10; i<=20; i++) {
      XIo_Out8( VGA_START +14+i*W, 1+32);
      grid[14][i]=1;
    }
    /*
    for(i=19; i<=22; i++) {
      XIo_Out8( VGA_START +16+i*W, 1+32);
      grid[16][i]=1;
    }
    */

    for(i=10; i<=22; i++) {
      XIo_Out8( VGA_START +19+i*W, 1+32);
      grid[19][i]=1;
    }
    for(i=13; i<=22; i++) {
      XIo_Out8( VGA_START +25+i*W, 1+32);
      grid[25][i]=1;
    }

    /*
     {3,13,3,20,1},//6
     {3,13,24,13,2},//7
     {5,15,24,15,2},//8
     {5,15,5,22,1},//9
     {3,15,5,15,2}, //10
    */

    
    for(i=13; i<=20; i++){
      XIo_Out8( VGA_START +3+i*W, 1+32);
      grid[3][i]=1;
    }
    for(i=3; i<=12; i++) {
      XIo_Out8( VGA_START +i+13*W, 2+32);
      grid[i][13]=2;
    }
    /*
  
    
    
        {20,18,20,32,1},//11
	{24,22,27,22,2},//12
	{3,25,8,25,2},//13
	{3,25,3,50,1},//14
	{8,25,8,50,1},//15
    */

    for(i=18; i<=30; i++){
      XIo_Out8( VGA_START +22+i*W, 1+32);
      grid[22][i]=1;
    }
    /*
    for(i=24; i<=27; i++) {
      XIo_Out8( VGA_START +i+22*W, 2+32);
      grid[i][22]=2;
    }
    */
    for(i=3; i<=8; i++) {
      XIo_Out8( VGA_START +i+25*W, 2+32);
      grid[i][25]=2;
    }
    for(i=25; i<=50; i++) {
      XIo_Out8( VGA_START +3+i*W, 1+32);
      grid[3][i]=1;
    }
    for(i=25; i<=50; i++) {
      XIo_Out8( VGA_START +8+i*W, 1+32);
      grid[8][i]=1;
    }

    /*
       {3,55,12,55,2},//16
       {25,25,25,38,1},//17
       {20,34,20,52,1},//18 
       {20,43,25,43,2},//19
       {25,46,25,57,1},//20
    */

    for(i=3; i<=12; i++){
      XIo_Out8( VGA_START +i+55*W, 2+32);
      grid[i][55]=2;
    }
    for(i=25; i<=30; i++) {
      XIo_Out8( VGA_START +25+i*W, 1+32);
      grid[25][i]=1;
    }
    for(i=34; i<=52; i++) {
      XIo_Out8( VGA_START +20+i*W, 1+32);
      grid[20][i]=1;
    }
    for(i=20; i<=25; i++) {
      XIo_Out8( VGA_START +i+43*W, 2+32);
      grid[i][43]=2;
    }
    for(i=46; i<=56; i++) {
      XIo_Out8( VGA_START +25+i*W, 1+32);
      grid[25][i]=1;
    }

    /*
       {30,39,30,57,1},//21
       {30,57,40,57,2},//22
       {40,32,40,57,1},//23
       {20,32,35,32,2},//24
       {20,30,35,30,2},//25

    */


     for(i=39; i<=56; i++){
      XIo_Out8( VGA_START +30+i*W, 1+32);
      grid[30][i]=1;
    }
    for(i=30; i<=40; i++) {
      XIo_Out8( VGA_START +i+56*W, 2+32);
      grid[i][56]=2;
    }
    for(i=32; i<=56; i++) {
      XIo_Out8( VGA_START +40+i*W, 1+32);
      grid[40][i]=1;
    }
    for(i=20; i<=35; i++) {
      XIo_Out8( VGA_START +i+34*W, 2+32);
      grid[i][34]=2;
    }
    for(i=20; i<=35; i++) {
      XIo_Out8( VGA_START +i+30*W, 2+32);
      grid[i][30]=2;
    }
    /*
    {35,32,35,55,1},//26
    {20,15,20,25,2},//27
    {40,22,40,27,1},//28
    {40,3,40,25,1},//29
    {43,10,43,25,1},//30
    */
    for(i=34; i<=53; i++){
      XIo_Out8( VGA_START +35+i*W, 1+32);
      grid[35][i]=1;
    }
    for(i=23; i<=54; i++) {
      XIo_Out8( VGA_START +12+i*W, 1+32);
      grid[12][i]=2;
    }
    for(i=22; i<=27; i++) {
      XIo_Out8( VGA_START +40+i*W, 1+32);
      grid[40][i]=1;
    }
    for(i=5; i<=6; i++) {
      XIo_Out8( VGA_START +40+i*W, 1+32);
      grid[40][i]=1;
    }
    for(i=10; i<=25; i++) {
      XIo_Out8( VGA_START +43+i*W, 1+32);
      grid[43][i]=1;
    }

    /*
		    {43,10,63,10,2},//31
		    {50,13,72,13,2},//32  	 
		    {43,15,65,15,2},//33
		    {65,15,65,25,1},//34
		    {65,22,76,22,2},//35
    */
     for(i=43; i<=63; i++){
      XIo_Out8( VGA_START +i+10*W, 2+32);
      grid[i][10]=2;
    }
     /*
    for(i=50; i<=72; i++) {
      XIo_Out8( VGA_START +i+13*W, 2+32);
      grid[i][13]=2;
    }
     */
    for(i=43; i<=65; i++) {
      XIo_Out8( VGA_START +i+15*W, 2+32);
      grid[i][15]=2;
    }
    for(i=11; i<=20; i++) {
      XIo_Out8( VGA_START +64+i*W, 1+32);
      grid[65][i]=1;
    }
    for(i=68; i<=75; i++) {
      XIo_Out8( VGA_START +i+25*W, 2+32);
      grid[i][25]=2;
    }

    /*
       {67,3,67,20,1},//36
		    {70,10,70,22,1},//37
		    {73,3,73,20,1},//38
		    {40,5,40,35,1},//39
		    {43,25,43,55,1},//40  
    */
    for(i=5; i<=20; i++){
      XIo_Out8( VGA_START +67+i*W, 1+32);
      grid[67][i]=1;
    }
    for(i=10; i<=22; i++) {
      XIo_Out8( VGA_START +70+i*W, 1+32);
      grid[70][i]=1;
    }
    for(i=5; i<=20; i++) {
      XIo_Out8( VGA_START +73+i*W, 1+32);
      grid[73][i]=1;
    }
    for(i=5; i<=35; i++) {
      XIo_Out8( VGA_START +40+i*W, 1+32);
      grid[40][i]=1;
    }
    for(i=25; i<=54; i++) {
      XIo_Out8( VGA_START +43+i*W, 1+32);
      grid[43][i]=1;
    }

    /*
       {45,17,62,17,2},//41
       {45,17,45,32,1},//42
		    {47,39,47,57,1},//43
		    {48,15,48,39,1},//44
		    {50,15,50,42,1},//45

    */
    for(i=45; i<=62; i++){
      XIo_Out8( VGA_START +i+18*W, 2+32);
      grid[i][18]=2;
    }
    for(i=18; i<=32; i++) {
      XIo_Out8( VGA_START +45+i*W, 1+32);
      grid[45][i]=1;
    }
    for(i=39; i<=56; i++) {
      XIo_Out8( VGA_START +47+i*W, 1+32);
      grid[47][i]=1;
    }
    for(i=20; i<=40; i++) {
      XIo_Out8( VGA_START +50+i*W, 1+32);
      grid[50][i]=1;
    }
    for(i=19; i<=42; i++) {
      XIo_Out8( VGA_START +53+i*W, 1+32);
      grid[53][i]=1;
    }

    for(i=47; i<=50; i++) {
      XIo_Out8( VGA_START +i+40*W, 2+32);
      grid[i][40]=1;
    }



    /*
    {49,46,50,46,2},//46
		    {67,10,67,56,1},//47
		    {65,46,77,46,2},//48
		    {61,32,61,46,2},//49
		    {65,23,65,44,1},//50  
    
    for(i=49; i<=50; i++){
      XIo_Out8( VGA_START +i+46*W, 2+32);
      grid[i][46]=2;
    }
    */
    for(i=10; i<=56; i++) {
      XIo_Out8( VGA_START +67+i*W, 1+32);
      grid[67][i]=1;
    }
    for(i=50; i<=67; i++) {
      XIo_Out8( VGA_START +i+56*W, 2+32);
      grid[i][56]=2;
    }
    


    for(i=62; i<=76; i++) {
      XIo_Out8( VGA_START +i+46*W, 2+32);
      grid[i][46]=2;
    }
    for(i=34; i<=46; i++) {
      XIo_Out8( VGA_START +61+i*W, 1+32);
      grid[61][i]=1;
    }
    for(i=23; i<=43; i++) {
      XIo_Out8( VGA_START +64+i*W, 1+32);
      grid[64][i]=1;
    }
    /*
       {65,23,75,23,2}, //51
       {75,23,75,44,1},//52  

    
    
    for(i=73; i<=75; i++) {
      XIo_Out8( VGA_START +i+23*W, 2+32);
      grid[i][23]=2;
    }
    */
    for(i=25; i<=43; i++) {
      XIo_Out8( VGA_START +75+i*W, 1+32);
      grid[75][i]=1;
    }

    for(i=3; i<=35; i++){
      XIo_Out8( VGA_START +i+6*W, 2+32);
      grid[i][6]=2;
    }

    
    for(i=6; i<=26; i++){
      XIo_Out8( VGA_START +35+i*W, 1+32);
      grid[35][i]=1;
    }








/*
    //*********************paint walls***************************
    for(i=0; i<26; i++){
      if(map[i][0]==map[i][2]){
	for(y=map[i][1]; y<=map[i][3]; y++){
	  XIo_Out8( VGA_START + map[i][0]+y*W, map[i][4]+32);
	  grid[map[i][0]][y]=1;//establish that the space is occupied by a wall
	}
      }
      if(map[i][1]==map[i][3]){
	for(x=map[i][0]; x<=map[i][2]; x++){
	  XIo_Out8( VGA_START + x+map[i][1]*W, map[i][4]+32);
	  grid[x][map[i][1]]=2;  
	}
      }  
    } 
    */

    
    //*********************paint pellets*************************
    i=0;
    for(x=0 ; x<W ; x++){
      for(y=3; y<H; y++){
	if(grid[x][y]==0)emptyTile=TRUE;
	else emptyTile=FALSE;
	//for(j=0; j<term_size; j++){
	//  if((map[j][0]==map[j][2]) && (y>=map[j][1] && y<=map[j][3]) && x==map[j][0] ) emptyTile=FALSE;
	//  if((map[j][1]==map[j][3]) && (x>=map[j][0] && x<=map[j][2]) && y==map[j][1]) emptyTile=FALSE;
	//  if(!emptyTile)break;
	//}
	if(emptyTile==TRUE){
	  //create invulnerable pellet
	  if(i%1183==687){
	    grid[x][y]=4;
	    XIo_Out8(VGA_START + x+y*W, 112+9);
	  }
	  else if(i%1975==567){//create wall crunching pellet
	    grid[x][y]=5;
	    XIo_Out8(VGA_START + x+y*W, 32+9);
	  }
	  else if(i%1130==345){//create attack pellet
	    grid[x][y]=6;
	    XIo_Out8(VGA_START + x+y*W, 64+9);
	  }
	  else if(y==3 && x==6){
	    grid[x][y]=6;
	    XIo_Out8(VGA_START + x+y*W, 64+9);
	  }
	  else{
	    grid[x][y]=3;//establish that the space is occupied by pellet
	    XIo_Out8(VGA_START + x+y*W, 16+3);
	  }
	  i++;
	}
      }
    }
    

    totalscore=i;
    //Randomly place AIs
    for(i=0; i<AI_COUNT; i++){
      x=rand()%75+1;
      y=rand()%55+1;
      
      //check to see if space is not a wall
      while(grid[x][y]!=0 && grid[x][y]!=3){
	//if wall then pick another location 
	x=rand()%75+1;
	y=rand()%55+2;
      }
      allunits[i]->prevx=x;
      allunits[i]->prevy=y;
      allunits[i]->x=x;
      allunits[i]->y=y;
      allunits[i]->score=1;
      allunits[i]->direction=0;
      allunits[i]->alive=TRUE;
    }

    //paint player score tally
    if(PLAYER_COUNT>=1){
      XIo_Out8(VGA_START + 0, 15+48);
      XIo_Out8(VGA_START + 1, 11+48);
      for(i=0; i<20; i++){
	 XIo_Out8(VGA_START + 2+i, 3+80);
      }
    
    }
    
    if(PLAYER_COUNT==2){
      XIo_Out8(VGA_START + 77, 15+48);
      XIo_Out8(VGA_START + 78, 12+48);
      for(i=0; i<20; i++){
	 XIo_Out8(VGA_START + 57+i, 3+80);
      }
    
    }

    
    //animated opening game message
    /*
    while (header_delay<=1000000){
     if(header_delay==0)
     {
      
     }
     else if(header_delay==1000000){
       for(i=36; i<46; i++) XIo_Out8(VGA_START + i, ' ');
     }
    
     header_delay= (header_delay==5000000)? 5000000 : (header_delay+1);

    }
    */


    player_delay=0;
    for (;;) 
    {
        // disable interrupts while reading count since it can be
        // changed inside the isr concurrently
        
      
       

        microblaze_disable_interrupts();
	if(player_clock!=0  && player_clock!=-1){
	if(player_delay<20){

	  if(change)player_delay--;
	  if(player_delay==0)change=FALSE;
	  if(!change)player_delay++;
	  if(p.alive || p2.alive){
	  //animate player
	    if(p.alive){
	      //if(p.direction==3)  XIo_Out8(VGA_START + p.x + (p.y*W), 6+96);
	      //if(p.direction==4 || p.direction==0) XIo_Out8(VGA_START + p.x + (p.y*W), 4+96);
	      //if(p.direction==1) XIo_Out8(VGA_START + p.x + (p.y*W), 7+96);
	      //if(p.direction==2) XIo_Out8(VGA_START + p.x + (p.y*W), 8+96);	    
	      /* 
	      if(p.direction==3){  
		//XIo_Out8(VGA_START + p.x + (p.y*W), 6+96);
		XIo_Out16(VGA_START+62,p.x*8);
		XIo_Out16(VGA_START+74,p.y*8);
		XIo_Out16(VGA_START+80,0);
	      }
	      if(p.direction==4 || p.direction==0){
		XIo_Out16(VGA_START+62,p.x*8);
		XIo_Out16(VGA_START+74,p.y*8);
		XIo_Out16(VGA_START+80,0);
		//XIo_Out8(VGA_START + p.x + (p.y*W), 4+96);
	      }
	      if(p.direction==1){
		XIo_Out16(VGA_START+62,p.x*8);
		XIo_Out16(VGA_START+74,p.y*8);
		XIo_Out16(VGA_START+80,0);

		//XIo_Out8(VGA_START + p.x + (p.y*W), 7+96);
	      }
	      if(p.direction==2){
		XIo_Out16(VGA_START+62,p.x*8);
		XIo_Out16(VGA_START+74,p.y*8);
		XIo_Out16(VGA_START+80,0);
		//XIo_Out8(VGA_START + p.x + (p.y*W), 8+96);
	      }
	      */
	      
	        
	      if(p.prevx<p.x){  
		    //XIo_Out8(VGA_START + p.x + (p.y*W), 6+96);
		XIo_Out16(VGA_START+62,(p.prevx*8)+player_clock);
		XIo_Out16(VGA_START+74,p.y*8);
		XIo_Out16(VGA_START+80,1);
	      }
	      if(p.prevx>p.x){
		XIo_Out16(VGA_START+62,(p.prevx*8)-player_clock);
		XIo_Out16(VGA_START+74,p.y*8);
		XIo_Out16(VGA_START+80,2);
		//XIo_Out8(VGA_START + p.x + (p.y*W), 4+96);
	      }
	      if(p.prevy>p.y){
		XIo_Out16(VGA_START+62,p.x*8);
		XIo_Out16(VGA_START+74,(p.prevy*8)-player_clock);
		XIo_Out16(VGA_START+80,4);

		//XIo_Out8(VGA_START + p.x + (p.y*W), 7+96);
	      }
	      if(p.prevy<p.y){
		XIo_Out16(VGA_START+62,p.x*8);
		XIo_Out16(VGA_START+74,(p.prevy*8)+player_clock);
		XIo_Out16(VGA_START+80,3);
		//XIo_Out8(VGA_START + p.x + (p.y*W), 8+96);
	      }
	      if(p.prevy==p.y && p.prevx==p.x){
		XIo_Out16(VGA_START+62,p.prevx*8);
		XIo_Out16(VGA_START+74,p.prevy*8);
		XIo_Out16(VGA_START+80,1);
		//XIo_Out8(VGA_START + p.x + (p.y*W), 8+96);
	      }
	      
	      




	    }

	    if(PLAYER_COUNT>1 && p2.alive){
	      if(p2.direction==3)  XIo_Out8(VGA_START + p2.x + (p2.y*W), 6+96);
	      if(p2.direction==4 || p2.direction==0) XIo_Out8(VGA_START + p2.x + (p2.y*W), 4+96);
	      if(p2.direction==1) XIo_Out8(VGA_START + p2.x + (p2.y*W), 7+96);
	      if(p2.direction==2) XIo_Out8(VGA_START + p2.x + (p2.y*W), 8+96);	    
	    }



	    //animate enemy
	  
	  }

	  

 
	    
	   
	}
	else {
	  if(p.alive){
	     if(p.prevx<p.x){  
		    //XIo_Out8(VGA_START + p.x + (p.y*W), 6+96);
		XIo_Out16(VGA_START+62,(p.prevx*8)+player_clock);
		XIo_Out16(VGA_START+74,p.y*8);
		XIo_Out16(VGA_START+80,5);
	      }
	      if(p.prevx>p.x){
		XIo_Out16(VGA_START+62,(p.prevx*8)-player_clock);
		XIo_Out16(VGA_START+74,p.y*8);
		XIo_Out16(VGA_START+80,5);
		//XIo_Out8(VGA_START + p.x + (p.y*W), 4+96);
	      }
	      if(p.prevy>p.y){
		XIo_Out16(VGA_START+62,p.x*8);
		XIo_Out16(VGA_START+74,(p.prevy*8)-player_clock);
		XIo_Out16(VGA_START+80,6);

		//XIo_Out8(VGA_START + p.x + (p.y*W), 7+96);
	      }
	      if(p.prevy<p.y){
		XIo_Out16(VGA_START+62,p.x*8);
		XIo_Out16(VGA_START+74,(p.prevy*8)+player_clock);
		XIo_Out16(VGA_START+80,7);
		//XIo_Out8(VGA_START + p.x + (p.y*W), 8+96);
	      }
	      if(p.prevy==p.y && p.prevx==p.x){
		XIo_Out16(VGA_START+62,p.prevx*8);
		XIo_Out16(VGA_START+74,p.prevy*8);
		XIo_Out16(VGA_START+80,5);
		//XIo_Out8(VGA_START + p.x + (p.y*W), 8+96);
	      }
	   
	    //XIo_Out8(VGA_START + p.x + (p.y*W), 5+96);
	  
	  }
	    //if(PLAYER_COUNT>1){
	  //if(p2.alive)XIo_Out8(VGA_START + p2.x + (p2.y*W), 5+96);
	  //}


	  //for(i=0; i<AI_COUNT; i++){
	  //if(allunits[i]->alive)XIo_Out8(VGA_START+allunits[i]->x+(allunits[i]->y*W),10+16);
	  //}
	  if(player_delay==40)change=TRUE;
	  if(change)player_delay--;
	  else player_delay++;
	    
	}
	
	if(!p.alive){
	  XIo_Out16(VGA_START+62,p.x*8);
	  XIo_Out16(VGA_START+74,p.y*8);
	  XIo_Out16(VGA_START+80,0);
	}



        for(i=0; i<AI_COUNT; i++){
	  if(allunits[i]->alive){
	    XIo_Out8(VGA_START+allunits[i]->prevx+(allunits[i]->prevy*W),0);
	    XIo_Out8(VGA_START+allunits[i]->x+(allunits[i]->y*W),10+16);
	    
	  }
	}



	if(player_clock==8)player_clock=-1;//reset clock

	}//end if player_Clock
	else if(player_clock==0){  //if player_Clock is equal to 0
	
	
	

	i=1;
	j=p.score;
	if(WIN_SCORE!=0) j=(j*20/WIN_SCORE);
	else j=(j*20)/totalscore;
	for(i=0; i<20; i++){
	   if(i<=j)XIo_Out8(VGA_START + 2+i, 3+48);
	}


		
	if(PLAYER_COUNT==2){ 
	  i=1;
	  j=p2.score;
	  if(WIN_SCORE!=0) j=(j*20/WIN_SCORE);
	  else j=(j*20)/totalscore;
	  for(i=0; i<20; i++){
	    if(i<=j)XIo_Out8(VGA_START + 76-i, 3+48);
	  }
	  
	}
	




	 //checks duration of player special powers
       
	  // check invulnerability of players
	  if(PLAYER_COUNT==2){
	    if(p2.invulnerable){
	      p2.it--;
	      if(p2.it<=0){
		p2.invulnerable=FALSE;
		make_invulnerable(2,0);
	      }
	    }
	  }
	  if(p.invulnerable){
	    p.it--;
	    if(p.it<=0){
	      p.invulnerable=FALSE;
	      make_invulnerable(1,0);
	    }
	  }


	  //checks wall chewing ability of players
	  if(PLAYER_COUNT==2){
	    if(p2.chewing){
	      p2.ct--;
	      if(p2.ct<=0){
		p2.chewing=FALSE;
		make_chewing(2,0);
	      }    
	    } 
	  }
	  if(p.chewing){
	    p.ct--;
	    if(p.ct<=0){
	      p.chewing=FALSE;
	      make_chewing(1,0);
	    }
	  }


	  //checks attack ability
	   if(PLAYER_COUNT==2){
	    if(p2.attack){
	      p2.at--;
	      if(p2.at<=0){
		p2.attack=FALSE;
		make_attack(2,0);
	      }    
	    } 
	  }
	  if(p.attack){
	    p.at--;
	    if(p.at<=0){
	      p.attack=FALSE;
	      make_attack(1,0);
	    }
	  }




	if(PLAYER_COUNT==2){
	  if(!p.alive && !p2.alive){
	    lost_game(1);
	    lost_game(2);
	  }
	}
	else{
	  if(!p.alive)lost_game(1);
	}


	//******************************
	//user defined win condition
	//******************************
	if(p.alive && p.score>=WIN_SCORE){
	  won_game(1);
	  //kill all AI's
	  for(i=0; i<AI_COUNT; i++){
	    allunits[i]->alive=FALSE;
	  }
	  if(PLAYER_COUNT==2 && p2.score<p.score)lost_game(2);
	}
	if(PLAYER_COUNT==2){
	  //tie
	  if(p2.alive && p2.score>=WIN_SCORE && p.score<WIN_SCORE){
	    won_game(2);
	    lost_game(1);
	    for(i=0; i<AI_COUNT; i++){
	      allunits[i]->alive=FALSE;
	    }
	  }
	}





	k=FALSE;
	for(i=0; i<W; i++){
	  for(j=0; j<H; j++){
	    if(grid[i][j]==3){
	      k=TRUE;
	      break;
	    }
	  }
	}

	//*********************************
	//default win condition all pellets have been eaten
	//*********************************
	if(!k){
	  end_game();
	  if(PLAYER_COUNT==2){
	    if(p.alive && p2.alive){
	      if(p.score>p2.score){
		won_game(1);
	      }
	      else if(p.score<p2.score){
		won_game(2);
	      }
	    }
	  }
	  else{
	    if(p.alive)won_game(1);
	  }
	}

	

	for(i=0; i<1000000; i++);
	    

        microblaze_enable_interrupts();
	if(count!=0){
	  tmp = buffer[head];
          count--;
          head++;
          head = (head >= BUF_SIZE) ? (head - BUF_SIZE) : head;
        }
	
      
	if(tmp==P1UP){
	  p.direction=1;
	}
	else if(tmp==P1DOWN){
	  p.direction=2;
	}
	else if(tmp==P1LEFT){
	  p.direction=3;
	}
	else if(tmp==P1RIGHT){
	  p.direction=4;
	}
	else if(tmp==P1PAUSE){
	  p.direction=0;
	}
	else if(tmp==P2UP){
	  p2.direction=1;
	}
	else if(tmp==P2DOWN){
	  p2.direction=2;
	}
	else if(tmp==P2LEFT){
	  p2.direction=3;
	}
	else if(tmp==P2RIGHT){
	  p2.direction=4;
	}
	else if(tmp==P2PAUSE){
	  p2.direction=0;
	}

	//else{
	//p.direction=0;
	//}
 

	if(p.alive){


	if(p.direction==1){
	   test_x=p.x;
	   test_y=p.y-1;
	}
	else if(p.direction==2){
	   test_x=p.x;
	   test_y=p.y+1;
	}
	else if(p.direction==3){
	   test_x=p.x-1;
	   test_y=p.y;
	}
	else if(p.direction==4){
	  test_x=p.x+1;
	  test_y=p.y;
	}
	else if(p.direction==0){
	  test_x=p.x;
	  test_y=p.y;
	}

        //Player1 Game logic
	x=p.x;
	y=p.y;
	p.prevx=x;
	p.prevy=y;
	
	if(grid[test_x][test_y]!=1 && grid[test_x][test_y]!=2 && grid[test_x+1][test_y]!=1 && grid[test_x+1][test_y]!=2 && grid[test_x+1][test_y+1]!=1 && grid[test_x+1][test_y+1]!=2  && grid[test_x][test_y+1]!=1 && grid[test_x][test_y+1]!=2    ){
	  XIo_Out8(VGA_START + x + (y*W), 0);
	  XIo_Out8(VGA_START + x+1 + (y*W), 0);
	  XIo_Out8(VGA_START + x + ((y+1)*W), 0);
	  XIo_Out8(VGA_START + x+1 + (y*W), 0);
	  


	  if(grid[test_x][test_y]==3){
	    p.score++;
	    grid[test_x][test_y]=0;
	  }
	  if(grid[test_x][test_y]==4){
	    p.invulnerable=TRUE;
	    p.it=200;
	    make_invulnerable(1,1);
	    p.score++;
	    grid[test_x][test_y]=0;
	  }
	  if(grid[test_x][test_y]==5){
	    p.chewing=TRUE;
	    p.ct=200;
	    make_chewing(1,1);
	    p.score++;
	    grid[test_x][test_y]=0;
	  }
	  if(grid[test_x][test_y]==6){
	    p.attack=TRUE;
	    p.at=200;
	    make_attack(1,1);
	    p.score++;
	    grid[test_x][test_y]=0;
	  }

	  
	  if(grid[test_x+1][test_y]==3){
	    p.score++;
	    grid[test_x+1][test_y]=0;
	  }
	  if(grid[test_x+1][test_y]==4){
	    p.invulnerable=TRUE;
	    p.it=200;
	    make_invulnerable(1,1);
	    p.score++;
	    grid[test_x+1][test_y]=0;
	  }
	  if(grid[test_x+1][test_y]==5){
	    p.chewing=TRUE;
	    p.ct=200;
	    make_chewing(1,1);
	    p.score++;
	    grid[test_x+1][test_y]=0;
	  }
	  if(grid[test_x+1][test_y]==6){
	    p.attack=TRUE;
	    p.at=200;
	    make_attack(1,1);
	    p.score++;
	    grid[test_x+1][test_y]=0;
	  }

	  if(grid[test_x+1][test_y+1]==3){
	    p.score++;
	    grid[test_x+1][test_y+1]=0;
	  }
	  if(grid[test_x+1][test_y+1]==4){
	    p.invulnerable=TRUE;
	    p.it=200;
	    make_invulnerable(1,1);
	    p.score++;
	    grid[test_x+1][test_y+1]=0;
	  }
	  if(grid[test_x+1][test_y+1]==5){
	    p.chewing=TRUE;
	    p.ct=200;
	    make_chewing(1,1);
	    p.score++;
	    grid[test_x+1][test_y+1]=0;
	  }
	  if(grid[test_x+1][test_y+1]==6){
	    p.attack=TRUE;
	    p.at=200;
	    make_attack(1,1);
	    p.score++;
	    grid[test_x+1][test_y+1]=0;
	  }
	  


	  
	  if(grid[test_x][test_y+1]==3){
	    p.score++;
	    grid[test_x][test_y+1]=0;
	  }
	  if(grid[test_x][test_y+1]==4){
	    p.invulnerable=TRUE;
	    p.it=200;
	    make_invulnerable(1,1);
	    p.score++;
	    grid[test_x][test_y+1]=0;
	  }
	  if(grid[test_x][test_y+1]==5){
	    p.chewing=TRUE;
	    p.ct=200;
	    make_chewing(1,1);
	    p.score++;
	    grid[test_x][test_y+1]=0;
	  }
	  if(grid[test_x][test_y+1]==6){
	    p.attack=TRUE;
	    p.at=200;
	    make_attack(1,1);
	    p.score++;
	    grid[test_x][test_y+1]=0;
	  }





	  p.x=test_x;
	  p.y=test_y;
	}
	else{//hitting a wall
	  if(p.chewing){
	    if(test_x!=0 && test_x!=79 && test_y!=2 && test_y!=59 && test_x+1!=0 && test_x+1!=79 && test_y+1!=2 && test_y+1!=59){
	      XIo_Out8(VGA_START + x + (y*W), 0);
	      if(grid[test_x][test_y+1]==1 ){
		 grid[test_x][test_y+1]=0;
		XIo_Out8(VGA_START + x + ((y+1)*W), 0);
	      }
	      else{
		 grid[test_x][test_y+1]=0;
		XIo_Out8(VGA_START + x+1 + y*W , 0);
	      }
	      grid[test_x][test_y]=0;
	      p.x=test_x;
	      p.y=test_y;
	    }
	  }
	}
	
	//player moves onto AI
	for(i=0; i<AI_COUNT; i++){
	  if(((p.x==allunits[i]->x && p.y==allunits[i]->y)||(p.x+1==allunits[i]->x && p.y==allunits[i]->y)||(p.x==allunits[i]->x && p.y+1==allunits[i]->y)|| (p.x+1==allunits[i]->x && p.y+1==allunits[i]->y ))&& p.attack )allunits[i]->alive=FALSE;
	  else if(p.x==allunits[i]->x && p.y==allunits[i]->y && !p.attack &&!p.invulnerable){
	    p.alive=FALSE;
	    lost_game(1);
	  }
	}

	for(i=0; i<AI_COUNT; i++){
	  if(((p.prevx==allunits[i]->x && p.prevy==allunits[i]->y)||(p.prevx+1==allunits[i]->x && p.prevy==allunits[i]->y)||(p.prevx==allunits[i]->x && p.prevy+1==allunits[i]->y)|| (p.prevx+1==allunits[i]->x && p.prevy+1==allunits[i]->y ))&& p.attack )allunits[i]->alive=FALSE;
	  else if(p.prevx==allunits[i]->x && p.prevy==allunits[i]->y && !p.attack &&!p.invulnerable){
	    p.alive=FALSE;
	    lost_game(1);
	  }
	}






	

	}
	if(p2.alive){
	//Player 2 game logic
	if(p2.direction==1){
	   test_x=p2.x;
	   test_y=p2.y-1;
	}
	else if(p2.direction==2){
	   test_x=p2.x;
	   test_y=p2.y+1;
	}
	else if(p2.direction==3){
	   test_x=p2.x-1;
	   test_y=p2.y;
	}
	else if(p2.direction==4){
	  test_x=p2.x+1;
	  test_y=p2.y;
	}
	else if(p2.direction==0){
	  test_x=p2.x;
	  test_y=p2.y;
	}

        //Player2 Game logic
	if(PLAYER_COUNT>1){
	  
	  x=p2.x;
	  y=p2.y;
	  if(grid[test_x][test_y]!=1 && grid[test_x][test_y]!=2){
	    XIo_Out8(VGA_START + x + (y*W), 0);
	    if(grid[test_x][test_y]==3){
	      p2.score++;
	      grid[test_x][test_y]=0;
	    }
	    if(grid[test_x][test_y]==4){
	      p2.invulnerable=TRUE;
	      p2.it=200;
	      make_invulnerable(2,1);
	      p2.score++;
	      grid[test_x][test_y]=0;
	    }
	    if(grid[test_x][test_y]==5){
	      p2.chewing=TRUE;
	      p2.ct=200;
	      make_chewing(2,1);
	      p2.score++;
	      grid[test_x][test_y]=0;
	    }
	    if(grid[test_x][test_y]==6){
	      p2.attack=TRUE;
	      p2.at=200;
	      make_attack(2,1);
	      p2.score++;
	      grid[test_x][test_y]=0;
	    }
	    p2.x=test_x;
	    p2.y=test_y;
	  }
	  else{//hitting a wall
	    if(p2.chewing){
	      if(test_x!=0 && test_x!=79 && test_y!=2 && test_y!=59){
		XIo_Out8(VGA_START + x + (y*W), 0);
		grid[test_x][test_y]=0;
		p2.x=test_x;
		p2.y=test_y;
	      }
	    }
	  }


	   //player moves onto AI
	  for(i=0; i<AI_COUNT; i++){
	    if(p2.x==allunits[i]->x && p2.y==allunits[i]->y && p2.attack)allunits[i]->alive=FALSE;
	    else if(p2.x==allunits[i]->x && p2.y==allunits[i]->y && !p2.attack && !p2.invulnerable){
	      lost_game(2);
	      p2.alive=FALSE;
	    }
	  }

	}
	}

  
	zx=0;
	
	//AI game logic
	for(x=0; x<AI_COUNT; x++){
	  if(allunits[x]->alive){
	  
	  allunits[x]->prevx=allunits[x]->x;
	  allunits[x]->prevy=allunits[x]->y;
	

	//path finding for AI  
	i=rand()%3;
	zx=allunits[x]->x;
	zy=allunits[x]->y;
	
	j=0;
	
	if(PLAYER_COUNT==2){
	  j=(p.x-allunits[x]->x)*(p.x-allunits[x]->x)+ (p.y-allunits[x]->y)*(p.y-allunits[x]->y);
	  k=(p2.x-allunits[x]->x)*(p2.x-allunits[x]->x)+ (p2.y-allunits[x]->y)*(p2.y-allunits[x]->y);
	  if(p.alive && p2.alive){
	    if(j<k){
	      j=0;
	    }
	    else{
	      j=1;
	    }	
	  }
	  else if(p.alive && !p2.alive){
	    j=0;
	  }
	  else{
	    j=1;
	  }
	}
	//horizontal/vertical tracking
	if(i!=0){
	  k=1;
	if(allplayers[j]->attack)k=-1;
	newmove=TRUE;

	if(allplayers[j]->x>zx){
	  zx+=k;
	  if(zx!=0 && zx!=79 && zy!=2 && zy!=59)newmove=FALSE;
	  else zx-=k;
	}
	
	if(allplayers[j]->x<zx  && newmove==TRUE){
	  zx-=k; 
	  if(zx!=0 && zx!=79 && zy!=2 && zy!=59)newmove=FALSE;
	  else zx+=k;
	}
	
	if(allplayers[j]->y>zy && newmove==TRUE){
	  zy+=k;
	  if(zx!=0 && zx!=79 && zy!=2 && zy!=59)newmove=FALSE;
	  else zy-=k;
	}
	
	if(allplayers[j]->y<zy  && newmove==TRUE){
	  zy-=k;
	  if(zx!=0 && zx!=79 && zy!=2 && zy!=59)newmove=FALSE;
	  else zy+=k;
	}

	
	if(allplayers[j]->x==zx  && newmove==TRUE){
	  if(k!=1){
	    zx-=1;
	    if(zx==0 || zx==79 || zy==2 || zy==59){
	      zx+=2;
    
	    }
	  }
	}

	
	if(allplayers[j]->y==zy  && newmove==TRUE){
	  if(k!=1){
	    zy-=1;
	    if(zx==0 || zx==79 || zy==2 || zy==59){
	      zy+=2;
    
	    }
	  }
	}

	


	}

	//if AI is in defensive mode....make sure not to run off screen
	if(zx!=0 && zx!=79 && zy!=2 && zy!=59){
	  allunits[x]->x=zx;
	  allunits[x]->y=zy;
	}

	//collision resolution
	if(allunits[x]->x!=allunits[x]->prevx || allunits[x]->y!=allunits[x]->prevy){
	  //AI moves on player
	  if(allunits[x]->x==allplayers[j]->x && allunits[x]->y==allplayers[j]->y){
	    //if player not attack or invulnerable....player gets killed
	    if(!allplayers[j]->invulnerable && !allplayers[j]->attack){
	      allplayers[j]->alive=FALSE;
	      lost_game(j+1);
	    }
	    else if(allplayers[j]->attack){//if player is attacking...AI gets killed
	      allunits[x]->alive=FALSE;
	    }
	  }

	  
	  //player moves on AI
	   if(allunits[x]->prevx==allplayers[j]->x && allunits[x]->prevy==allplayers[j]->y){
	 
	     if(!allplayers[j]->invulnerable && !allplayers[j]->attack){
	      allplayers[j]->alive=FALSE;
	      lost_game(j+1);
	    }
	    else if(allplayers[j]->attack){
	      allunits[x]->alive=FALSE;
	    }
	  }
	   

	  

	   if(grid[allunits[x]->x][allunits[x]->y]!=1 && grid[allunits[x]->x][allunits[x]->y]!=2 && grid[allunits[x]->x+1][allunits[x]->y]!=1 && grid[allunits[x]->x+1][allunits[x]->y]!=2 && grid[allunits[x]->x+1][allunits[x]->y+1]!=1 && grid[allunits[x]->x+1][allunits[x]->y+1]!=2 && grid[allunits[x]->x][allunits[x]->y+1]!=1 && grid[allunits[x]->x][allunits[x]->y+1]!=2){


	  if(grid[allunits[x]->prevx][allunits[x]->prevy]!=1 && grid[allunits[x]->prevx][allunits[x]->prevy]!=2){
	    XIo_Out8(VGA_START + allunits[x]->prevx + (allunits[x]->prevy*W),0);
	    //grid[allunits[x]->prevx][allunits[x]->prevy]=0;
	  }
	  else{//AI's eat through walls
	     if(grid[allunits[x]->prevx][allunits[x]->prevy]==1){
	       grid[allunits[x]->prevx][allunits[x]->prevy+1]=0;
	        XIo_Out8(VGA_START + allunits[x]->prevx + ((allunits[x]->prevy+1)*W),0);
	     }
	     if(grid[allunits[x]->prevx][allunits[x]->prevy]==2){
	       grid[allunits[x]->prevx+1][allunits[x]->prevy]=0;
	        XIo_Out8(VGA_START + allunits[x]->prevx+1 + ((allunits[x]->prevy)*W),0);
	     }
	     
	       grid[allunits[x]->prevx][allunits[x]->prevy]=0;
	   
	    XIo_Out8(VGA_START + allunits[x]->prevx + (allunits[x]->prevy*W),0);
	  }
	
	   }

	}
	

	  }
      


	}
       
	}//end else
	
	player_clock++;

	//unit_delay=0;
	//while(unit_delay<100000){
	//unit_delay++;
	//}


       
	}
  
    return 0;
}


